adc => Gain g => blackhole;

MAUI_View myWinder; myWinder.size(300.0,150.0);
MAUI_Slider high; high.name("High peak"); high.range(-1.0,1.0); 
MAUI_Slider low;   low.name("Low peak");   low.range(-1.0,1.0);
high.position(0.0,0.0); low.position(0.0,60.0);
MAUI_Button exit; exit.name("Exit"); exit.position(220.0,0.0);
myWinder.addElement(high); myWinder.addElement(low);
myWinder.addElement(exit);
myWinder.display();

spork ~ getPeaks();

0.0 => float highPeak;
0.0 => float lowPeak;

1 => int running;

while (running)	{
    0.1 :: second => now;
    highPeak => high.value;
    lowPeak => low.value;
	(1-exit.state())=>running;
}

fun void getPeaks()	{
    float min,max;
    while (running)	{
		1 :: samp => now;
		min*0.9999 => min => lowPeak;
		max*0.9999 => max => highPeak;
		if (g.last() < min) g.last() => min;
		if (g.last() > max)	g.last() => max;
    }
}

myWinder.destroy();
